--- /dev/null	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/localeimpl.c	Tue May 20 07:58:48 2014
@@ -0,0 +1,470 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ */
+
+/*
+ * This file implements the 2008 newlocale and friends handling.
+ */
+
+#ifndef	_LCONV_C99
+#define	_LCONV_C99
+#endif
+
+#include "lint.h"
+#include <atomic.h>
+#include <locale.h>
+#include <sys/types.h>
+#include <sys/mman.h>
+#include <errno.h>
+#include <string.h>
+#include "libc.h"
+#include "mtlib.h"
+#include "tsd.h"
+#include "localeimpl.h"
+#include "lctype.h"
+
+/*
+ * Big Theory of Locales:
+ *
+ * (It is recommended that readers familiarize themselves with the POSIX
+ * 2008 (XPG Issue 7) specifications for locales, first.)
+ *
+ * Historically, we had a bunch of global variables that stored locale
+ * data.  While this worked well, it limited applications to a single locale
+ * at a time.  This doesn't work well in certain server applications.
+ *
+ * Issue 7, X/Open introduced the concept of a locale_t object, along with
+ * versions of functions that can take this object as a parameter, along
+ * with functions to clone and manipulate these locale objects.  The new
+ * functions are named with a _l() suffix.
+ *
+ * Additionally uselocale() is introduced which can change the locale of
+ * of a single thread.  However, setlocale() can still be used to change
+ * the global locale.
+ *
+ * In our implementation, we use libc's TSD to store the locale data that
+ * was previously global.  We still have global data because some applications
+ * have had those global objects compiled into them.  (Such applications will
+ * be unable to benefit from uselocale(), btw.)  The legacy routines are
+ * reimplemented as wrappers that use the appropriate locale object by
+ * calling uselocale().  uselocale() when passed a NULL pointer returns the
+ * thread-specific locale object if one is present, or the global locale
+ * object otherwise.  Note that once the TSD data is set, the only way
+ * to revert to the global locale is to pass the global locale LC_GLOBAL_LOCALE
+ * to uselocale().
+ *
+ * We are careful to minimize performance impact of multiple calls to
+ * uselocale() or setlocale() by using a cache of locale data whenever possible.
+ * As a consequence of this, applications that iterate over all possible
+ * locales will burn through a lot of virtual memory, but we find such
+ * applications rare.  (locale -a might be an exception, but it is short lived.)
+ */
+
+/*
+ * NB: Each of the structures listed herein should have the refcnt
+ * set to -1, to ensure that posix locale information is never ever freed,
+ * even when changing the global locale.
+ */
+
+typedef struct locdata *(*loadfn_t)(const char *);
+
+static const loadfn_t loaders[LC_ALL] = {
+	__lc_ctype_load,
+	__lc_numeric_load,
+	__lc_time_load,
+	__lc_collate_load,
+	__lc_monetary_load,
+	__lc_messages_load,
+};
+
+extern struct lc_monetary lc_monetary_posix;
+extern struct lc_numeric lc_numeric_posix;
+extern struct lc_messages lc_messages_posix;
+extern struct lc_time lc_time_posix;
+extern struct lc_ctype lc_ctype_posix;
+extern struct lc_collate lc_collate_posix;
+
+static struct locale posix_locale = {
+	/* locdata */
+	.locdata = {
+		&__posix_ctype_locdata,
+		&__posix_numeric_locdata,
+		&__posix_time_locdata,
+		&__posix_collate_locdata,
+		&__posix_monetary_locdata,
+		&__posix_messages_locdata,
+	},
+	.ctype = &lc_ctype_posix,
+	.numeric = &lc_numeric_posix,
+	.collate = &lc_collate_posix,
+	.monetary = &lc_monetary_posix,
+	.messages = &lc_messages_posix,
+	.time = &lc_time_posix,
+	.runelocale = &_DefaultRuneLocale,
+};
+
+locale_t __global_locale = &posix_locale;
+
+/*
+ * Category names for getenv()  Note that this was modified
+ * for Solaris.  See <iso/locale_iso.h>.
+ */
+#define	NUM_CATS	7
+static char *categories[7] = {
+	"LC_CTYPE",
+	"LC_NUMERIC",
+	"LC_TIME",
+	"LC_COLLATE",
+	"LC_MONETARY",
+	"LC_MESSAGES",
+	"LC_ALL",
+};
+
+/*
+ * Prototypes.
+ */
+static const char *get_locale_env(int);
+static struct locdata *locdata_get(int, const const char *);
+static struct locdata *locdata_get_cache(int, const char *);
+static void locdata_set_cache(int, struct locdata *);
+
+/*
+ * Some utility routines.
+ */
+struct locdata *
+__locdata_hold(struct locdata *ld)
+{
+	if (ld != NULL && ld->l_refcnt != (uint32_t)-1)
+		atomic_inc_32(&ld->l_refcnt);
+	return (ld);
+}
+
+void
+__locdata_release(struct locdata *ld)
+{
+	if (ld->l_refcnt == (uint32_t)-1)
+		return;
+
+	if (atomic_dec_32_nv(&ld->l_refcnt) == 0) {
+		for (int i = 0; i < NLOCDATA; i++)
+			free(ld->l_data[i]);
+		if (ld->l_map && ld->l_map_len) {
+			(void) munmap(ld->l_map, ld->l_map_len);
+		}
+		free(ld);
+	}
+}
+
+struct locdata *
+__locdata_alloc(const char *name, size_t memsz)
+{
+	struct locdata *ldata;
+
+	if ((ldata = calloc(1, sizeof (*ldata))) == NULL) {
+		return (NULL);
+	}
+	if ((ldata->l_data[0] = calloc(1, memsz)) == NULL) {
+		free(ldata);
+		errno = ENOMEM;
+		return (NULL);
+	}
+	(void) strlcpy(ldata->l_lname, name, sizeof (ldata->l_lname));
+	ldata->l_refcnt = 1;
+
+	return (ldata);
+}
+
+/*
+ * It turns out that for performance reasons we would really like to
+ * cache the most recently referenced locale data to avoid wasteful
+ * loading from files.
+ */
+
+static struct locdata *cache_data[LC_ALL];
+static mutex_t cache_lock = DEFAULTMUTEX;
+
+/*
+ * Returns the cached data if the locale name is the same.  If not,
+ * returns NULL (cache miss).  The locdata is returned with a hold on
+ * it, taken on behalf of the caller.  The caller should drop the hold
+ * when it is finished.
+ */
+static struct locdata *
+locdata_get_cache(int category, const char *locname)
+{
+	struct locdata *loc;
+
+	if (category < 0 || category >= LC_ALL)
+		return (NULL);
+
+	lmutex_lock(&cache_lock);
+	if ((loc = cache_data[category]) != NULL) {
+		if (strcmp(locname, loc->l_lname) == 0) {
+			loc = __locdata_hold(loc);
+		} else {
+			loc = NULL;
+		}
+	}
+	lmutex_unlock(&cache_lock);
+	return (loc);
+}
+
+/*
+ * Set the cache for the category to specific content.  An additional hold
+ * is taken for the data while it is in the cache, so the caller may drop
+ * its own hold once this is complete.  Also, releases the hold on any
+ * previously cached data.
+ */
+static void
+locdata_set_cache(int category, struct locdata *loc)
+{
+	struct locdata *old;
+
+	if (category < 0 || category >= LC_ALL)
+		return;
+
+	lmutex_lock(&cache_lock);
+	old = cache_data[category];
+	cache_data[category] = __locdata_hold(loc);
+	lmutex_unlock(&cache_lock);
+
+	/* drop our reference on the old data */
+	if (old)
+		__locdata_release(old);
+}
+
+/*
+ * Routine to get the locdata for a given category and locale.
+ * This includes retrieving it from cache, retrieving it from
+ * a file, etc.
+ */
+static struct locdata *
+locdata_get(int category, const char *locname)
+{
+	struct locdata *ldata;
+	char scratch[ENCODING_LEN + 1];
+	char *slash;
+	int cnt;
+	int len;
+
+	if (locname == NULL || *locname == 0) {
+		locname = get_locale_env(category);
+	}
+
+	/*
+	 * Extract the locale name for the category if it is a composite
+	 * locale.
+	 */
+	if ((slash = strchr(locname, '/')) != NULL) {
+		for (cnt = category; cnt && slash != NULL; cnt--) {
+			locname = slash + 1;
+			slash = strchr(locname, '/');
+		}
+		if (slash) {
+			len = slash - locname;
+			if (len >= sizeof (scratch)) {
+				len = sizeof (scratch);
+			}
+		} else {
+			len = sizeof (scratch);
+		}
+		(void) strlcpy(scratch, locname, len);
+		locname = scratch;
+	}
+
+	if ((strcmp(locname, "C") == 0) || (strcmp(locname, "POSIX") == 0))
+		return (__locdata_hold(posix_locale.locdata[category]));
+
+	ldata = locdata_get_cache(category, locname);
+	if (ldata != NULL)
+		return (ldata);
+
+	/* Otherwise load it */
+	ldata = (*loaders[category])(locname);
+	if (ldata != NULL) {
+		locdata_set_cache(category, ldata);
+	}
+	return (ldata);
+}
+
+/* tsd destructor */
+static void
+freelocptr(void *arg)
+{
+	locale_t *locptr = arg;
+	if (*locptr != NULL)
+		freelocale(*locptr);
+}
+
+static const char *
+get_locale_env(int category)
+{
+	const char *env;
+
+	/* 1. check LC_ALL. */
+	env = getenv(categories[LC_ALL]);
+
+	/* 2. check LC_* */
+	if (env == NULL || *env == '\0')
+		env = getenv(categories[category]);
+
+	/* 3. check LANG */
+	if (env == NULL || *env == '\0')
+		env = getenv("LANG");
+
+	/* 4. if none is set, fall to "C" */
+	if (env == NULL || *env == '\0')
+		env = "C";
+
+	return (env);
+}
+
+
+/*
+ * This routine is exposed via the MB_CUR_MAX macro.  Note that legacy
+ * code will continue to use _ctype[520], but we prefer this function as
+ * it is the only way to get thread-specific information.
+ */
+unsigned char
+__mb_cur_max_l(locale_t loc)
+{
+	return (loc->ctype->lc_max_mblen);
+}
+
+unsigned char
+__mb_cur_max(void)
+{
+	return (__mb_cur_max_l(uselocale(NULL)));
+}
+
+/*
+ * Public interfaces.
+ */
+
+locale_t
+duplocale(locale_t src)
+{
+	locale_t	loc;
+	int		i;
+
+	loc = calloc(1, sizeof (*loc));
+	if (loc == NULL) {
+		return (NULL);
+	}
+	for (i = 0; i < LC_ALL; i++) {
+		loc->locdata[i] = __locdata_hold(src->locdata[i]);
+		loc->loaded[i] = 0;
+	}
+	loc->collate = loc->locdata[LC_COLLATE]->l_data[0];
+	loc->ctype = loc->locdata[LC_CTYPE]->l_data[0];
+	loc->runelocale = loc->locdata[LC_CTYPE]->l_data[1];
+	loc->messages = loc->locdata[LC_MESSAGES]->l_data[0];
+	loc->monetary = loc->locdata[LC_MONETARY]->l_data[0];
+	loc->numeric = loc->locdata[LC_NUMERIC]->l_data[0];
+	loc->time = loc->locdata[LC_TIME]->l_data[0];
+	return (loc);
+}
+
+void
+freelocale(locale_t loc)
+{
+	int i;
+	for (i = 0; i < LC_ALL; i++)
+		__locdata_release(loc->locdata[i]);
+	if (loc != &posix_locale)
+		free(loc);
+}
+
+locale_t
+newlocale(int catmask, const char *locname, locale_t base)
+{
+	locale_t loc;
+	int i, e;
+
+	if (catmask & ~(LC_ALL_MASK)) {
+		errno = EINVAL;
+		return (NULL);
+	}
+	loc = duplocale(base != NULL ? base : __global_locale);
+	if (loc == NULL) {
+		return (NULL);
+	}
+
+	for (i = 0; i < LC_ALL; i++) {
+		struct locdata *ldata;
+		loc->loaded[i] = 0;
+		if (((1 << i) & catmask) == 0) {
+			/* Default to base locale if not overriding */
+			continue;
+		}
+		ldata = locdata_get(i, locname);
+		if (ldata == NULL) {
+			e = errno;
+			freelocale(loc);
+			errno = e;
+			return (NULL);
+		}
+		__locdata_release(loc->locdata[i]);
+		loc->locdata[i] = ldata;
+	}
+	if (base && base != __global_locale) {
+		freelocale(base);
+	}
+	loc->collate = loc->locdata[LC_COLLATE]->l_data[0];
+	loc->ctype = loc->locdata[LC_CTYPE]->l_data[0];
+	loc->runelocale = loc->locdata[LC_CTYPE]->l_data[1];
+	loc->messages = loc->locdata[LC_MESSAGES]->l_data[0];
+	loc->monetary = loc->locdata[LC_MONETARY]->l_data[0];
+	loc->numeric = loc->locdata[LC_NUMERIC]->l_data[0];
+	loc->time = loc->locdata[LC_TIME]->l_data[0];
+	return (loc);
+}
+
+locale_t
+uselocale(locale_t loc)
+{
+	locale_t lastloc = __global_locale;
+	locale_t *locptr;
+
+	locptr = tsdalloc(_T_SETLOCALE, sizeof (locale_t), freelocptr);
+	/* Should never occur */
+	if (locptr == NULL) {
+		errno = EINVAL;
+		return (NULL);
+	}
+
+	if (*locptr != NULL)
+		lastloc = *locptr;
+
+	/* Argument loc is NULL if we are just querying. */
+	if (loc != NULL) {
+		/*
+		 * Set it to LC_GLOBAL_LOCAL to return to using
+		 * the global locale (setlocale).
+		 */
+		if (loc == __global_locale) {
+			*locptr = NULL;
+		} else {
+			/* No validation of the provided locale at present */
+			*locptr = loc;
+		}
+	}
+
+	/*
+	 * The caller is responsible for freeing, of course it would be
+	 * gross error to call freelocale() on a locale object that is still
+	 * in use.
+	 */
+	return (lastloc);
+}
--- /dev/null	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/localeimpl.h	Tue May 20 07:58:48 2014
@@ -0,0 +1,103 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ */
+
+/*
+ * This file implements the 2008 newlocale and friends handling. It is
+ * private to libc.
+ */
+#ifndef	_LOCALEIMPL_H_
+#define	_LOCALEIMPL_H_
+
+#ifndef _LCONV_C99
+#define	_LCONV_C99	/* so we get all the extensions */
+#endif
+
+#include <sys/types.h>
+#include <locale.h>
+#include <xlocale.h>
+#include "setlocale.h"
+#include "runetype.h"
+
+/* private locale structures */
+
+/*
+ * Because some locale data is rather ahem.. large, we would like to keep
+ * reference counts on it.  We create an abstract header (locdata) structure
+ * which keeps a point to the opaque per-category data, along with a reference
+ * count to it.  To be threadsafe, we will use atomics when holding it or
+ * freeing it.  (This only occurs when locale objects are created or destroyed,
+ * so there should be no performance impact on hot code paths.  If your code
+ * uses locale_t creation/destruction on a hot code path, its broken.  But
+ * even so, the atomic and reference counting will probably *greatly* improve
+ * your life as bootstrapping locale data from files is quite expensive.
+ */
+
+#define	NLOCDATA	4
+struct locdata {
+	char		l_lname[ENCODING_LEN+1];	/* locale name */
+	void		*l_data[NLOCDATA];		/* storage area */
+	void		*l_map;				/* mapped file */
+	size_t		l_map_len;
+	uint32_t	l_refcnt;
+};
+
+
+struct locale {
+	struct locdata	*locdata[LC_ALL];
+
+	/*
+	 * Convenience pointers.
+	 */
+	const struct lc_ctype		*ctype;
+	const struct lc_collate		*collate;
+	const struct lc_messages	*messages;
+	const struct lc_monetary	*monetary;
+	const struct lc_numeric		*numeric;
+	const struct lc_time		*time;
+	const _RuneLocale		*runelocale;
+
+	/*
+	 * The loaded value is used for localeconv.  In paticular, when
+	 * when we change the value of one of the above categories, we will
+	 * also need to update the lconv structure.  The loaded bit indicates
+	 * that the lconv structure is "current" for that category.  It's
+	 * sort of an "inverse dirty" bit.
+	 */
+	int		loaded[LC_ALL];
+	struct lconv	lconv;
+};
+
+
+struct locdata *__locdata_alloc(const char *, size_t);
+struct locdata *__locdata_hold(struct locdata *);
+void __locdata_release(struct locdata *);
+struct locdata *__locdata_get_cache(int, const char *);
+void __locdata_set_cache(int, struct locdata *);
+
+struct locdata *__lc_numeric_load(const char *name);
+struct locdata *__lc_monetary_load(const char *name);
+struct locdata *__lc_messages_load(const char *name);
+struct locdata *__lc_time_load(const char *name);
+struct locdata *__lc_ctype_load(const char *name);
+struct locdata *__lc_collate_load(const char *name);
+
+extern struct locdata	__posix_numeric_locdata;
+extern struct locdata	__posix_monetary_locdata;
+extern struct locdata	__posix_messages_locdata;
+extern struct locdata	__posix_time_locdata;
+extern struct locdata	__posix_ctype_locdata;
+extern struct locdata	__posix_collate_locdata;
+
+#endif	/* _LOCALEIMPL_H_ */
--- old/usr/src/lib/libc/port/locale/mblen.c	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/mblen.c	Tue May 20 07:58:48 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -28,10 +29,13 @@
 #include "lint.h"
 #include <stdlib.h>
 #include <wchar.h>
+#include <locale.h>
+#include <xlocale.h>
 #include "mblocal.h"
+#include "localeimpl.h"
 
 int
-mblen(const char *s, size_t n)
+mblen_l(const char *s, size_t n, locale_t loc)
 {
 	static const mbstate_t initial = { 0 };
 	static mbstate_t mbs;
@@ -42,8 +46,14 @@
 		mbs = initial;
 		return (0);
 	}
-	rval = __mbrtowc(NULL, s, n, &mbs);
+	rval = mbrtowc_l(NULL, s, n, &mbs, loc);
 	if (rval == (size_t)-1 || rval == (size_t)-2)
 		return (-1);
 	return ((int)rval);
+}
+
+int
+mblen(const char *s, size_t n)
+{
+	return (mblen_l(s, n, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/mblocal.h	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/mblocal.h	Tue May 20 07:58:48 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2004 Tim J. Robbins.
  * All rights reserved.
@@ -29,43 +30,31 @@
 #define	_MBLOCAL_H_
 
 #include "runetype.h"
+#include "lctype.h"
 
 /*
  * Rune initialization function prototypes.
  */
-int	_none_init(_RuneLocale *);
-int	_UTF8_init(_RuneLocale *);
-int	_EUC_CN_init(_RuneLocale *);
-int	_EUC_JP_init(_RuneLocale *);
-int	_EUC_KR_init(_RuneLocale *);
-int	_EUC_TW_init(_RuneLocale *);
-int	_GB18030_init(_RuneLocale *);
-int	_GB2312_init(_RuneLocale *);
-int	_GBK_init(_RuneLocale *);
-int	_BIG5_init(_RuneLocale *);
-int	_MSKanji_init(_RuneLocale *);
+void	_none_init(struct lc_ctype *);
+void	_UTF8_init(struct lc_ctype *);
+void	_EUC_CN_init(struct lc_ctype *);
+void	_EUC_JP_init(struct lc_ctype *);
+void	_EUC_KR_init(struct lc_ctype *);
+void	_EUC_TW_init(struct lc_ctype *);
+void	_GB18030_init(struct lc_ctype *);
+void	_GB2312_init(struct lc_ctype *);
+void	_GBK_init(struct lc_ctype *);
+void	_BIG5_init(struct lc_ctype *);
+void	_MSKanji_init(struct lc_ctype *);
 
-/*
- * Conversion function pointers for current encoding.
- */
-extern size_t (*__mbrtowc)(wchar_t *_RESTRICT_KYWD,
+typedef size_t (*mbrtowc_pfn_t)(wchar_t *_RESTRICT_KYWD,
     const char *_RESTRICT_KYWD, size_t, mbstate_t *_RESTRICT_KYWD);
-extern int (*__mbsinit)(const mbstate_t *);
-extern size_t (*__mbsnrtowcs)(wchar_t *_RESTRICT_KYWD,
-    const char **_RESTRICT_KYWD, size_t, size_t, mbstate_t *_RESTRICT_KYWD);
-
-extern size_t (*__wcrtomb)(char *_RESTRICT_KYWD, wchar_t,
+typedef size_t (*wcrtomb_pfn_t)(char *_RESTRICT_KYWD, wchar_t,
     mbstate_t *_RESTRICT_KYWD);
-
-extern size_t (*__wcsnrtombs)(char *_RESTRICT_KYWD,
-    const wchar_t **_RESTRICT_KYWD, size_t, size_t, mbstate_t *_RESTRICT_KYWD);
-
-extern int charset_is_ascii;
-
 size_t __mbsnrtowcs_std(wchar_t *_RESTRICT_KYWD, const char **_RESTRICT_KYWD,
-    size_t, size_t, mbstate_t *_RESTRICT_KYWD);
+    size_t, size_t, mbstate_t *_RESTRICT_KYWD, mbrtowc_pfn_t);
 size_t __wcsnrtombs_std(char *_RESTRICT_KYWD, const wchar_t **_RESTRICT_KYWD,
-    size_t, size_t, mbstate_t *_RESTRICT_KYWD);
+    size_t, size_t, mbstate_t *_RESTRICT_KYWD, wcrtomb_pfn_t);
 
 #define	MIN(a, b)	((a) < (b) ? (a) : (b))
 
--- old/usr/src/lib/libc/port/locale/mbrlen.c	Tue May 20 07:58:49 2014
+++ new/usr/src/lib/libc/port/locale/mbrlen.c	Tue May 20 07:58:49 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -27,14 +28,23 @@
 
 #include "lint.h"
 #include <wchar.h>
+#include <locale.h>
+#include <xlocale.h>
 #include "mblocal.h"
 
 size_t
-mbrlen(const char *_RESTRICT_KYWD s, size_t n, mbstate_t *_RESTRICT_KYWD ps)
+mbrlen_l(const char *_RESTRICT_KYWD s, size_t n, mbstate_t *_RESTRICT_KYWD ps,
+    locale_t loc)
 {
 	static mbstate_t mbs;
 
 	if (ps == NULL)
 		ps = &mbs;
-	return (__mbrtowc(NULL, s, n, ps));
+	return (mbrtowc_l(NULL, s, n, ps, loc));
+}
+
+size_t
+mbrlen(const char *_RESTRICT_KYWD s, size_t n, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (mbrlen_l(s, n, ps, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/mbrtowc.c	Tue May 20 07:58:49 2014
+++ new/usr/src/lib/libc/port/locale/mbrtowc.c	Tue May 20 07:58:49 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -28,14 +29,23 @@
 #include "lint.h"
 #include <wchar.h>
 #include "mblocal.h"
+#include "localeimpl.h"
+#include "lctype.h"
 
 size_t
-mbrtowc(wchar_t *_RESTRICT_KYWD pwc, const char *_RESTRICT_KYWD s,
-    size_t n, mbstate_t *_RESTRICT_KYWD ps)
+mbrtowc_l(wchar_t *_RESTRICT_KYWD pwc, const char *_RESTRICT_KYWD s,
+    size_t n, mbstate_t *_RESTRICT_KYWD ps, locale_t loc)
 {
 	static mbstate_t mbs;
 
 	if (ps == NULL)
 		ps = &mbs;
-	return (__mbrtowc(pwc, s, n, ps));
+	return (loc->ctype->lc_mbrtowc(pwc, s, n, ps));
+}
+
+size_t
+mbrtowc(wchar_t *_RESTRICT_KYWD pwc, const char *_RESTRICT_KYWD s,
+    size_t n, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (mbrtowc_l(pwc, s, n, ps, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/mbsinit.c	Tue May 20 07:58:49 2014
+++ new/usr/src/lib/libc/port/locale/mbsinit.c	Tue May 20 07:58:49 2014
@@ -1,37 +1,31 @@
 /*
- * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
- * Copyright (c) 2002-2004 Tim J. Robbins.
- * All rights reserved.
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
  *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
  */
 
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ */
+
 #include "lint.h"
-#include <wchar.h>
-#include "mblocal.h"
+#include <locale.h>
+#include "localeimpl.h"
+#include "lctype.h"
 
 int
-mbsinit(const mbstate_t *ps)
+mbsinit_l(const mbstate_t *s, locale_t loc)
 {
+	return (loc->ctype->lc_mbsinit(s));
+}
 
-	return (__mbsinit(ps));
+int
+mbsinit(const mbstate_t *s)
+{
+	return (mbsinit_l(s, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/mbsnrtowcs.c	Tue May 20 07:58:49 2014
+++ new/usr/src/lib/libc/port/locale/mbsnrtowcs.c	Tue May 20 07:58:49 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -31,22 +32,32 @@
 #include <stdlib.h>
 #include <wchar.h>
 #include "mblocal.h"
+#include "localeimpl.h"
+#include "lctype.h"
 
 size_t
-mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst, const char **_RESTRICT_KYWD src,
-    size_t nms, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+mbsnrtowcs_l(wchar_t *_RESTRICT_KYWD dst, const char **_RESTRICT_KYWD src,
+    size_t nms, size_t len, mbstate_t *_RESTRICT_KYWD ps, locale_t loc)
 {
 	static mbstate_t mbs;
 
 	if (ps == NULL)
 		ps = &mbs;
-	return (__mbsnrtowcs(dst, src, nms, len, ps));
+	return (loc->ctype->lc_mbsnrtowcs(dst, src, nms, len, ps));
 }
 
 size_t
-__mbsnrtowcs_std(wchar_t *_RESTRICT_KYWD dst, const char **_RESTRICT_KYWD src,
+mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst, const char **_RESTRICT_KYWD src,
     size_t nms, size_t len, mbstate_t *_RESTRICT_KYWD ps)
 {
+	return (mbsnrtowcs_l(dst, src, nms, len, ps, uselocale(NULL)));
+}
+
+size_t
+__mbsnrtowcs_std(wchar_t *_RESTRICT_KYWD dst, const char **_RESTRICT_KYWD src,
+    size_t nms, size_t len, mbstate_t *_RESTRICT_KYWD ps,
+    mbrtowc_pfn_t pmbrtowc)
+{
 	const char *s;
 	size_t nchr;
 	wchar_t wc;
@@ -57,7 +68,7 @@
 
 	if (dst == NULL) {
 		for (;;) {
-			if ((nb = __mbrtowc(&wc, s, nms, ps)) == (size_t)-1)
+			if ((nb = pmbrtowc(&wc, s, nms, ps)) == (size_t)-1)
 				/* Invalid sequence - mbrtowc() sets errno. */
 				return ((size_t)-1);
 			else if (nb == 0 || nb == (size_t)-2)
@@ -70,7 +81,7 @@
 	}
 
 	while (len-- > 0) {
-		if ((nb = __mbrtowc(dst, s, nms, ps)) == (size_t)-1) {
+		if ((nb = pmbrtowc(dst, s, nms, ps)) == (size_t)-1) {
 			*src = s;
 			return ((size_t)-1);
 		} else if (nb == (size_t)-2) {
--- old/usr/src/lib/libc/port/locale/mbsrtowcs.c	Tue May 20 07:58:49 2014
+++ new/usr/src/lib/libc/port/locale/mbsrtowcs.c	Tue May 20 07:58:49 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -26,19 +27,24 @@
  */
 
 #include "lint.h"
-#include <errno.h>
+#include <locale.h>
 #include <limits.h>
 #include <stdlib.h>
 #include <wchar.h>
 #include "mblocal.h"
+#include "localeimpl.h"
+#include "lctype.h"
 
 size_t
+mbsrtowcs_l(wchar_t *_RESTRICT_KYWD dst, const char **_RESTRICT_KYWD src,
+    size_t len, mbstate_t *_RESTRICT_KYWD ps, locale_t loc)
+{
+	return (loc->ctype->lc_mbsnrtowcs(dst, src, ULONG_MAX, len, ps));
+}
+
+size_t
 mbsrtowcs(wchar_t *_RESTRICT_KYWD dst, const char **_RESTRICT_KYWD src,
     size_t len, mbstate_t *_RESTRICT_KYWD ps)
 {
-	static mbstate_t mbs;
-
-	if (ps == NULL)
-		ps = &mbs;
-	return (__mbsnrtowcs(dst, src, ULONG_MAX, len, ps));
+	return (mbsrtowcs_l(dst, src, len, ps, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/mbstowcs.c	Tue May 20 07:58:49 2014
+++ new/usr/src/lib/libc/port/locale/mbstowcs.c	Tue May 20 07:58:49 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -29,10 +30,14 @@
 #include <limits.h>
 #include <stdlib.h>
 #include <wchar.h>
+#include <locale.h>
 #include "mblocal.h"
+#include "localeimpl.h"
+#include "lctype.h"
 
 size_t
-mbstowcs(wchar_t *_RESTRICT_KYWD pwcs, const char *_RESTRICT_KYWD s, size_t n)
+mbstowcs_l(wchar_t *_RESTRICT_KYWD pwcs, const char *_RESTRICT_KYWD s,
+    size_t n, locale_t loc)
 {
 	static const mbstate_t initial = { 0 };
 	mbstate_t mbs;
@@ -40,5 +45,11 @@
 
 	mbs = initial;
 	sp = s;
-	return (__mbsnrtowcs(pwcs, &sp, ULONG_MAX, n, &mbs));
+	return (loc->ctype->lc_mbsnrtowcs(pwcs, &sp, ULONG_MAX, n, &mbs));
+}
+
+size_t
+mbstowcs(wchar_t *_RESTRICT_KYWD pwcs, const char *_RESTRICT_KYWD s, size_t n)
+{
+	return (mbstowcs_l(pwcs, s, n, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/mbtowc.c	Tue May 20 07:58:49 2014
+++ new/usr/src/lib/libc/port/locale/mbtowc.c	Tue May 20 07:58:49 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -28,10 +29,13 @@
 #include "lint.h"
 #include <stdlib.h>
 #include <wchar.h>
+#include <locale.h>
+#include <xlocale.h>
 #include "mblocal.h"
 
 int
-mbtowc(wchar_t *_RESTRICT_KYWD pwc, const char *_RESTRICT_KYWD s, size_t n)
+mbtowc_l(wchar_t *_RESTRICT_KYWD pwc, const char *_RESTRICT_KYWD s, size_t n,
+    locale_t loc)
 {
 	static const mbstate_t initial = { 0 };
 	static mbstate_t mbs;
@@ -42,8 +46,14 @@
 		mbs = initial;
 		return (0);
 	}
-	rval = __mbrtowc(pwc, s, n, &mbs);
+	rval = mbrtowc_l(pwc, s, n, &mbs, loc);
 	if (rval == (size_t)-1 || rval == (size_t)-2)
 		return (-1);
 	return ((int)rval);
+}
+
+int
+mbtowc(wchar_t *_RESTRICT_KYWD pwc, const char *_RESTRICT_KYWD s, size_t n)
+{
+	return (mbtowc_l(pwc, s, n, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/mskanji.c	Tue May 20 07:58:49 2014
+++ new/usr/src/lib/libc/port/locale/mskanji.c	Tue May 20 07:58:49 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins. All rights reserved.
  *
@@ -37,11 +38,11 @@
 #include "lint.h"
 #include <sys/types.h>
 #include <errno.h>
-#include "runetype.h"
 #include <stdlib.h>
 #include <string.h>
 #include <wchar.h>
 #include "mblocal.h"
+#include "lctype.h"
 
 static size_t	_MSKanji_mbrtowc(wchar_t *_RESTRICT_KYWD,
 		    const char *_RESTRICT_KYWD,
@@ -49,22 +50,28 @@
 static int	_MSKanji_mbsinit(const mbstate_t *);
 static size_t	_MSKanji_wcrtomb(char *_RESTRICT_KYWD, wchar_t,
 		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_MSKanji_mbsnrtowcs(wchar_t *_RESTRICT_KYWD,
+		    const char **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_MSKanji_wcsnrtombs(char *_RESTRICT_KYWD,
+		    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
 
 typedef struct {
 	wchar_t	ch;
 } _MSKanjiState;
 
-int
-_MSKanji_init(_RuneLocale *rl)
+void
+_MSKanji_init(struct lc_ctype *lct)
 {
 
-	__mbrtowc = _MSKanji_mbrtowc;
-	__wcrtomb = _MSKanji_wcrtomb;
-	__mbsinit = _MSKanji_mbsinit;
-	_CurrentRuneLocale = rl;
-	__ctype[520] = 2;
-	charset_is_ascii = 0;
-	return (0);
+	lct->lc_mbrtowc = _MSKanji_mbrtowc;
+	lct->lc_wcrtomb = _MSKanji_wcrtomb;
+	lct->lc_mbsnrtowcs = _MSKanji_mbsnrtowcs;
+	lct->lc_wcsnrtombs = _MSKanji_wcsnrtombs;
+	lct->lc_mbsinit = _MSKanji_mbsinit;
+	lct->lc_max_mblen = 2;
+	lct->lc_is_ascii = 0;
 }
 
 static int
@@ -153,4 +160,20 @@
 	for (i = len; i-- > 0; )
 		*s++ = wc >> (i << 3);
 	return (len);
+}
+
+static size_t
+_MSKanji_mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst,
+    const char **_RESTRICT_KYWD src, size_t nms,
+    size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__mbsnrtowcs_std(dst, src, nms, len, ps, _MSKanji_mbrtowc));
+}
+
+static size_t
+_MSKanji_wcsnrtombs(char *_RESTRICT_KYWD dst,
+    const wchar_t **_RESTRICT_KYWD src, size_t nwc,
+    size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__wcsnrtombs_std(dst, src, nwc, len, ps, _MSKanji_wcrtomb));
 }
